package com.jamesquinley.DelegationServices;

import com.mongodb.BasicDBObject;
import com.mongodb.ConnectionString;
import com.mongodb.MongoClientSettings;
import com.mongodb.MongoCommandException;
import com.mongodb.client.MongoClient;
import com.mongodb.client.MongoClients;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import com.mongodb.client.model.Filters;
import com.mongodb.client.model.Updates;
import org.bson.Document;

import static com.mongodb.client.model.Filters.eq;
import static java.util.concurrent.TimeUnit.SECONDS;

public class delegationServices {
    static ConnectionString scReadconnectionString = new ConnectionString("mongodb+srv://serverClient:ej2ookJGgpV6JyFS@accountdelegation.n06hb.mongodb.net/DelegationRequest?retryWrites=true&w=majority");
    static MongoClientSettings scReadsettings = MongoClientSettings.builder()
            .applyConnectionString(scReadconnectionString)
            .applyToSocketSettings(builder ->
                    builder.connectTimeout(5, SECONDS)
                            .readTimeout(6, SECONDS))
            .build();
    static MongoClient dClient = MongoClients.create(scReadsettings);
    static MongoDatabase dClientDatabase = dClient.getDatabase("DelegationRequest");
    static MongoCollection<Document> dCollection = dClientDatabase.getCollection("accountRequest");

    static ConnectionString AccountCon = new ConnectionString("mongodb+srv://DelegationServerClient:UNxldb8abSJkWscG@account.ufgrh.mongodb.net/account?retryWrites=true&w=majority");
    static MongoClientSettings AccountSettings = MongoClientSettings.builder()
            .applyConnectionString(AccountCon)
            .applyToSocketSettings(builder ->
                    builder.connectTimeout(5, SECONDS)
                            .readTimeout(6, SECONDS))
            .build();
    static MongoClient accountGetClient = MongoClients.create(AccountSettings);
    static MongoDatabase accountDatabase = accountGetClient.getDatabase("account");
    static MongoCollection<Document> accountS = accountDatabase.getCollection("UserPass");

    //still need to config
    public static void delegationProcesser() {
        Document Lrequest = dCollection.find(eq("status", false)).first();
        int ClientID = 0;
        try {
           ClientID = (int) Lrequest.get("clientid");
       } catch (Exception exrp) {
       }

        //TODO ADD BAN CHECK TO PREVENT BAN CIRCUMNAVIGATION, THIS WILL BE ADDED LATER
        String username = (String) Lrequest.get("User");
        String password = (String) Lrequest.get("Password");
        int requesttype = (int) Lrequest.get("type");
        if (requesttype == 0) {
            System.out.println("Sync Request (TKN)");
            String CTOKEN = (String) Lrequest.get("Token");
            Document accountServer;
            String Password;
            String Token;
            String Fname;
            String Path;
            String UserName;
            String Email;
            try {
                accountServer = accountS.find(eq("Token", CTOKEN)).first();
                Password = (String) accountServer.get("Token");
                if (accountServer.get("Status").equals("Active")) {
                    if (Password.equals(CTOKEN)) {
                        Token = (String) accountServer.get("Token");
                        Password = (String) accountServer.get("Password");
                        Fname = (String) accountServer.get("FName");
                        Path = (String) accountServer.get("Path");
                        Email = (String) accountServer.get("Email");
                        UserName = (String) accountServer.get("User");

                        BasicDBObject searchQuery = new BasicDBObject();
                        searchQuery.append("clientid", ClientID);

                        BasicDBObject updateQuery = new BasicDBObject();
                        BasicDBObject updateQuery1 = new BasicDBObject();
                        BasicDBObject updateQuery2 = new BasicDBObject();
                        BasicDBObject updateQuery3 = new BasicDBObject();
                        BasicDBObject updateQuery4 = new BasicDBObject();
                        BasicDBObject updateQuery5 = new BasicDBObject();
                        BasicDBObject updateQuery6 = new BasicDBObject();
                        BasicDBObject updateQuery7 = new BasicDBObject();
                        updateQuery.append("$set",
                                new BasicDBObject().append("type", 12));
                        updateQuery1.append("$set",
                                new BasicDBObject().append("token", Token));
                        updateQuery2.append("$set",
                                new BasicDBObject().append("Fname", Fname));
                        updateQuery3.append("$set",
                                new BasicDBObject().append("path", Path));
                        updateQuery4.append("$set",
                                new BasicDBObject().append("User", UserName));
                        updateQuery5.append("$set",
                                new BasicDBObject().append("Password", Password));
                        updateQuery7.append("$set",
                                new BasicDBObject().append("Email", Email));
                        updateQuery6.append("$set",
                                new BasicDBObject().append("status", true));
                        //    System.out.println("Sending Info To Forwarding Server");
                        dCollection.updateOne(searchQuery, updateQuery);
                        dCollection.updateOne(searchQuery, updateQuery1);
                        dCollection.updateOne(searchQuery, updateQuery2);
                        dCollection.updateOne(searchQuery, updateQuery3);
                        dCollection.updateOne(searchQuery, updateQuery4);
                        dCollection.updateOne(searchQuery, updateQuery5);
                        dCollection.updateOne(searchQuery, updateQuery6);
                        dCollection.updateOne(searchQuery, updateQuery7);
                        //delegationTimer.trigger();
                    } else {
                        System.out.println("Login Failure");
                        BasicDBObject searchQuery = new BasicDBObject();
                        searchQuery.append("clientid", ClientID);

                        BasicDBObject updateQuery = new BasicDBObject();
                        BasicDBObject updateQuery1 = new BasicDBObject();
                        updateQuery.append("$set",
                                new BasicDBObject().append("type", 9));
                        updateQuery1.append("$set",
                                new BasicDBObject().append("status", true));
                        dCollection.updateOne(searchQuery, updateQuery);
                        dCollection.updateOne(searchQuery, updateQuery1);
                        //delegationTimer.trigger();
                    }
                } else {
                    System.out.println("Banned Account");
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 11));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("status", true));
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                }
                }  catch(MongoCommandException ERC){
                    System.out.println("Malformed Request");
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 7));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("status", true));
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                    //delegationTimer.trigger();
                }
            }

            //sync read request
        if (requesttype == 1) {
//sync write request
            System.out.println("Sync Request (Write)");

        }
        if (requesttype == 2) {
            System.out.println("Login Request (USR&PASS)");
            Document accountServer;
            String Password;
            String Token;
            String Fname;
            String Path;
            String UserName;
            String Email;
        try {
            accountServer = accountS.find(eq("User", username)).first();
           Password = (String) accountServer.get("Password");
            if (accountServer.get("Status").equals("Active")) {
                if (Password.equals(password)) {
                    Token = (String) accountServer.get("Token");
                    Fname = (String) accountServer.get("FName");
                    Path = (String) accountServer.get("Path");
                    Email = (String) accountServer.get("Email");
                    UserName = (String) accountServer.get("User");

                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    BasicDBObject updateQuery2 = new BasicDBObject();
                    BasicDBObject updateQuery3 = new BasicDBObject();
                    BasicDBObject updateQuery4 = new BasicDBObject();
                    BasicDBObject updateQuery5 = new BasicDBObject();
                    BasicDBObject updateQuery6 = new BasicDBObject();
                    BasicDBObject updateQuery7 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 8));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("token", Token));
                    updateQuery2.append("$set",
                            new BasicDBObject().append("Fname", Fname));
                    updateQuery3.append("$set",
                            new BasicDBObject().append("path", Path));
                    updateQuery4.append("$set",
                            new BasicDBObject().append("User", UserName));
                    updateQuery5.append("$set",
                            new BasicDBObject().append("Password", Password));
                    updateQuery7.append("$set",
                            new BasicDBObject().append("Email", Email));
                    updateQuery6.append("$set",
                            new BasicDBObject().append("status", true));
                    //    System.out.println("Sending Info To Forwarding Server");
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                    dCollection.updateOne(searchQuery, updateQuery2);
                    dCollection.updateOne(searchQuery, updateQuery3);
                    dCollection.updateOne(searchQuery, updateQuery4);
                    dCollection.updateOne(searchQuery, updateQuery5);
                    dCollection.updateOne(searchQuery, updateQuery6);
                    dCollection.updateOne(searchQuery, updateQuery7);
                    //delegationTimer.trigger();
                } else {
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 7));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("status", true));
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                    //delegationTimer.trigger();
                }
            } else {
                System.out.println("Banned Account");
                BasicDBObject searchQuery = new BasicDBObject();
                searchQuery.append("clientid", ClientID);

                BasicDBObject updateQuery = new BasicDBObject();
                BasicDBObject updateQuery1 = new BasicDBObject();
                updateQuery.append("$set",
                        new BasicDBObject().append("type", 11));
                updateQuery1.append("$set",
                        new BasicDBObject().append("status", true));
                dCollection.updateOne(searchQuery, updateQuery);
                dCollection.updateOne(searchQuery, updateQuery1);
            }
            }  catch (Exception ERC) {
                BasicDBObject searchQuery = new BasicDBObject();
                searchQuery.append("clientid", ClientID);

                BasicDBObject updateQuery = new BasicDBObject();
                BasicDBObject updateQuery1 = new BasicDBObject();
                updateQuery.append("$set",
                        new BasicDBObject().append("type", 9));
                updateQuery1.append("$set",
                        new BasicDBObject().append("status", true));
                dCollection.updateOne(searchQuery, updateQuery);
                dCollection.updateOne(searchQuery, updateQuery1);
                //delegationTimer.trigger();
            }

            }
        if (requesttype == 3) {
            System.out.println("Login Request (TKN)");
           // Document TResolve = dCollection.find(eq("type", 3)).first();
            String CTOKEN = (String) Lrequest.get("Token");
            Document accountServer;
            String TKN;
            String Password;
            String Fname;
            String Path;
            String UserName;
            String Email;
            try {
                accountServer = accountS.find(eq("Token", CTOKEN)).first();
               TKN = (String) accountServer.get("Token");
                if (accountServer.get("Status").equals("Active")) {
                    if (TKN.equals(CTOKEN)) {
                        Password = (String) accountServer.get("Password");
                        Fname = (String) accountServer.get("FName");
                        Path = (String) accountServer.get("Path");
                        Email = (String) accountServer.get("Email");
                        UserName = (String) accountServer.get("User");

                        BasicDBObject searchQuery = new BasicDBObject();
                        searchQuery.append("clientid", ClientID);

                        BasicDBObject updateQuery = new BasicDBObject();
                        BasicDBObject updateQuery2 = new BasicDBObject();
                        BasicDBObject updateQuery3 = new BasicDBObject();
                        BasicDBObject updateQuery4 = new BasicDBObject();
                        BasicDBObject updateQuery5 = new BasicDBObject();
                        BasicDBObject updateQuery6 = new BasicDBObject();
                        BasicDBObject updateQuery7 = new BasicDBObject();
                        updateQuery.append("$set",
                                new BasicDBObject().append("type", 8));
                        updateQuery2.append("$set",
                                new BasicDBObject().append("Fname", Fname));
                        updateQuery3.append("$set",
                                new BasicDBObject().append("path", Path));
                        updateQuery4.append("$set",
                                new BasicDBObject().append("User", UserName));
                        updateQuery5.append("$set",
                                new BasicDBObject().append("Password", Password));
                        updateQuery7.append("$set",
                                new BasicDBObject().append("Email", Email));
                        updateQuery6.append("$set",
                                new BasicDBObject().append("status", true));
                        //    System.out.println("Sending Info To Forwarding Server");
                        dCollection.updateOne(searchQuery, updateQuery);
                        dCollection.updateOne(searchQuery, updateQuery2);
                        dCollection.updateOne(searchQuery, updateQuery3);
                        dCollection.updateOne(searchQuery, updateQuery4);
                        dCollection.updateOne(searchQuery, updateQuery5);
                        dCollection.updateOne(searchQuery, updateQuery6);
                        dCollection.updateOne(searchQuery, updateQuery7);
                        //delegationTimer.trigger();
                    } else {
                        System.out.println("Login Failure");
                        BasicDBObject searchQuery = new BasicDBObject();
                        searchQuery.append("clientid", ClientID);

                        BasicDBObject updateQuery = new BasicDBObject();
                        BasicDBObject updateQuery1 = new BasicDBObject();
                        updateQuery.append("$set",
                                new BasicDBObject().append("type", 9));
                        updateQuery1.append("$set",
                                new BasicDBObject().append("status", true));
                        dCollection.updateOne(searchQuery, updateQuery);
                        dCollection.updateOne(searchQuery, updateQuery1);
                        //delegationTimer.trigger();
                    }
                } else {
                    System.out.println("Banned Account");
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 11));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("status", true));
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                }
                }  catch (MongoCommandException ERC) {
                    System.out.println("Malformed Request");
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("clientid", ClientID);

                    BasicDBObject updateQuery = new BasicDBObject();
                    BasicDBObject updateQuery1 = new BasicDBObject();
                    updateQuery.append("$set",
                            new BasicDBObject().append("type", 7));
                    updateQuery1.append("$set",
                            new BasicDBObject().append("status", true));
                    dCollection.updateOne(searchQuery, updateQuery);
                    dCollection.updateOne(searchQuery, updateQuery1);
                    //delegationTimer.trigger();
                }
                }
        //above is finding one request and starting wheels
        //delegationTimer.trigger();
        delegate();
    }
        public static void Clear () {
            BasicDBObject searchQuery = new BasicDBObject();
            searchQuery.append("status", true);
            BasicDBObject searchQuery1 = new BasicDBObject();
            searchQuery1.append("status", false);
     //   dCollection.deleteMany(searchQuery);
          //  dCollection.deleteMany(searchQuery1);


        }
        public static void delegate ()
        {
            Document userLookMutedLookUp = dCollection.find(eq("status", false)).first();
            try {
                userAuthetication(userLookMutedLookUp);
            } catch (NullPointerException NPE) {
                System.out.println("No Pending Authentication Requests");
               delegationTimer.trigger();
            }
        }
        public static void userAuthetication (Document doc){
            try {
                delegationProcesser();
            } catch (Exception exr) {
                System.out.println("No Pending Authentication");
               delegationTimer.trigger();
            }
        }
    }
